function startBlinkingEffect(playerPed)
    local duration = 3214  
    local blinkInterval = getDynamicBlinkInterval(playerPed)

    SetEntityVisible(playerPed, false, false)  
    Citizen.Wait(blinkInterval)
    SetEntityVisible(playerPed, true, false) 
    Citizen.Wait(blinkInterval)

    local elapsedTime = 0
    while elapsedTime < duration do
        Citizen.Wait(blinkInterval)
        SetEntityVisible(playerPed, not IsEntityVisible(playerPed), false)
        elapsedTime = elapsedTime + blinkInterval
        blinkInterval = getDynamicBlinkInterval(playerPed) 
    end
end
function getDynamicBlinkInterval(playerPed)
    local health = GetEntityHealth(playerPed)
    local distanceToClosestVehicle = getDistanceToClosestVehicle(playerPed)

    if health < 50 then
        return 100 
    elseif distanceToClosestVehicle < 10 then
        return 200 
    else
        return 300
    end
end

function getDistanceToClosestVehicle(playerPed)
    local playerCoords = GetEntityCoords(playerPed)
    local vehicles = GetGamePool('CVehicle')
    local closestDistance = math.huge

    for _, vehicle in ipairs(vehicles) do
        local vehicleCoords = GetEntityCoords(vehicle)
        local distance = #(playerCoords - vehicleCoords)
        if distance < closestDistance then
            closestDistance = distance
        end
    end

    return closestDistance
end

AddEventHandler('playerSpawned', function(spawn)
    local playerPed = PlayerPedId() 
    startBlinkingEffect(playerPed)  
end)

AddEventHandler('playerConnecting', function(name, setCallback, deferrals)
    Citizen.Wait(1000)  
    local playerPed = PlayerPedId()  
    startBlinkingEffect(playerPed)   
end)

AddEventHandler('onPlayerDeath', function()
    local playerPed = PlayerPedId()  
    Citizen.Wait(3000) 
    startBlinkingEffect(playerPed) 
end)
