Citizen.CreateThread(function()
    local lastCheckTime = 0
    local checkInterval = 500 
    local collisionState = {} 
    local aiState = {} 

    while true do
        Citizen.Wait(100)
        local currentTime = GetGameTimer()
        
        if currentTime - lastCheckTime > checkInterval then
            lastCheckTime = currentTime
            local playerPed = PlayerPedId()
            local playerPos = GetEntityCoords(playerPed)
            local players = GetActivePlayers()

            for _, playerId in ipairs(players) do
                local targetPed = GetPlayerPed(playerId)
                local targetPos = GetEntityCoords(targetPed)
                local distance = Vdist(playerPos.x, playerPos.y, playerPos.z, targetPos.x, targetPos.y, targetPos.z)

                if aiState[targetPed] == nil then
                    aiState[targetPed] = {
                        lastDistance = distance,
                        isMovingCloser = false
                    }
                end

                if distance < aiState[targetPed].lastDistance then
                    aiState[targetPed].isMovingCloser = true
                else
                    aiState[targetPed].isMovingCloser = false
                end
                aiState[targetPed].lastDistance = distance

                if aiState[targetPed].isMovingCloser and distance < 50.0 then
                    TriggerEvent('chat:addMessage', {
                        args = {"AI Alert", "Pemain " .. tostring(playerId) .. " is approaching!"}
                    })
                end

                if collisionState[targetPed] == nil then
                    collisionState[targetPed] = true
                end
                if distance > 100.0 then
                    if IsEntityVisible(targetPed) then
                        SetEntityVisible(targetPed, false, false)
                    end
                    if collisionState[targetPed] then
                        SetEntityCollision(targetPed, false, false)
                        collisionState[targetPed] = false 
                    end
                else
                    if not IsEntityVisible(targetPed) then
                        SetEntityVisible(targetPed, true, false)
                    end
                    if not collisionState[targetPed] then
                        SetEntityCollision(targetPed, true, true)
                        collisionState[targetPed] = true 
                    end
                end
            end
        end
    end
end)
