
local AI = {}

function AI.onPlayerConnecting(playerName)
    print("[AI] Hello, " .. playerName .. "! Welcome to the server.")
end

function AI.onPlayerSpawned(playerName)
    print("[AI] Greetings, " .. playerName .. "! You've spawned into the world.")
end

function AI.onPlayerDied(playerName, killerId, deathCause)
    print("[AI] Oh no, " .. playerName .. "! You have died. Killer ID: " .. killerId .. ", Cause of death: " .. deathCause)
end

function AI.onPlayerDisconnect(playerName)
    print("[AI] " .. playerName .. " has disconnected. Goodbye!")
end

-- Add event handler for player connecting
AddEventHandler('playerConnecting', function(playerName, setKickReason, deferrals)
    print(playerName .. " is connecting to the server.")
    AI.onPlayerConnecting(playerName)
end)

AddEventHandler('playerSpawned', function()
    local playerName = GetPlayerName(source)
    print(playerName .. " has spawned into the world.")
    AI.onPlayerSpawned(playerName)
end)

AddEventHandler('playerDropped', function(reason)
    local playerName = GetPlayerName(source)
    print(playerName .. " has left the server. Reason: " .. reason)
end)

AddEventHandler('playerDied', function(killerId, deathCause)
    local playerName = GetPlayerName(source)
    print(playerName .. " has died. Killer ID: " .. killerId .. ", Cause of death: " .. deathCause)
    AI.onPlayerDied(playerName, killerId, deathCause)
end)

AddEventHandler('playerDisconnect', function()
    local playerName = GetPlayerName(source)
    print(playerName .. " has disconnected from the server.")
    AI.onPlayerDisconnect(playerName)
end)
